## hime 0.9.11+dfsg

=== Makefile ===
include config.mak

VERSION_FILE = ChangeLog

DIRS    = src data filter icons man menu scripts

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo | awk '{print $$2}')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

ifeq ($(USE_I18N),Y)
DIRS   += po
endif

.PHONY: all
all:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;33m** processing $$d\x1b[0m"; \
	   $(MAKE) -C $$d || exit 1; \
	done

.PHONY: install
install:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;32m** installing $$d\x1b[0m"; \
	   $(MAKE) -C $$d install || exit 1; \
	done
	install -d "$(DOC_DIR)"; \
	install -m 644 $(VERSION_FILE) "$(DOC_DIR)"

.PHONY: uninstall
uninstall:
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;32m** uninstalling $$d\x1b[0m"; \
	   $(MAKE) -C $$d uninstall || exit 1; \
	done

.PHONY: clean
clean:
	@touch src/.depend
	@for d in $(DIRS); do $(ECHO) -e "\x1b[1;31m** cleanup $$d\x1b[0m"; \
	   $(MAKE) -C $$d clean; \
	done

.PHONY: distclean
distclean:
	@$(MAKE) clean
	@rm -f config.mak

config.mak: $(VERSION_FILE) configure
	@$(ECHO) "regenerate $@ ..."
	./configure

.PHONY: clang-format
clang-format:
	clang-format -i {src,data}/*.[ch] \
		src/{gtk-im,im-client,modules}/*.[ch] \
		src/qt5-im/*.h \
		src/qt5-im/*.cpp \
		--verbose

=== scripts/Makefile ===
include ../config.mak

SCRIPTS=hime-user-setup utf8-edit gtab.append_prepare tsin-gtab-import
BIN_SCRIPTS=hime-env

.PHONY: all
all:	$(SCRIPTS)

.PHONY: install
install:
	install -d "$(HIME_SCRIPT_DIR)"
	install -m 755 $(SCRIPTS) "$(HIME_SCRIPT_DIR)"
	install -d "$(bindir)"
	install -m 755 $(BIN_SCRIPTS) "$(bindir)"

.PHONY: uninstall
uninstall:
	cd $(HIME_SCRIPT_DIR) && rm -f $(SCRIPTS)
	cd $(bindir) && rm -f $(BIN_SCRIPTS)
	rmdir --ignore-fail-on-non-empty $(bindir)
	rmdir --ignore-fail-on-non-empty $(HIME_SCRIPT_DIR)

.PHONY: clean
clean:
	@echo "clean up"
	@rm -f *~ tags core.*

=== distro/fedora/Makefile ===
SPEC         = hime-fedora.spec
VERSION_FILE = ../../ChangeLog


all: $(SPEC)

hime-fedora.spec: hime-fedora.spec.in $(VERSION_FILE)
	@echo "building $@ ..."
	@rm -f $@
	@sed -e "s/__hime_version__/`head -n 1 $(VERSION_FILE)`/" < $< > $@

clean:
	@rm -f $(SPEC)

=== src/im-client/Makefile ===
include ../../config.mak

SOFILE=libhime-im-client.so
SOFILEVER=libhime-im-client.so.1.2.4

.SUFFIXES:      .c .o .E .cpp
CFLAGS+= $(OPTFLAGS) $(GTKINC) \
		-DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
		-DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED \
		-DG_DISABLE_SINGLE_INCLUDES \
		-DCLIENT_LIB=1 \
		-DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" \
		-DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
		-DFREEBSD=$(FREEBSD) \
		-I. -I.. -I../IMdkit/include \
		-fPIC

DEPS = hime-common.o hime-conf.o hime-crypt.o hime-settings.o \
		locale.o im-addr.o pho2pinyin.o pinyin.o util.o
OBJS = hime-im-client.o hime-send.o $(DEPS)

.cpp.E:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<

.c.o:
	@echo "  $< -> $@"
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $<

.cpp.o:
	@echo "  $< -> $@"
	$(CC) -x c -c $(CPPFLAGS) $(CFLAGS) $<

$(SOFILEVER):   $(OBJS)
	@echo "linking $@ ..."

# TODO: Drop g_get_tmp_dir() and -lglib-2.0
ifeq ($(FREEBSD), 0)
	$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/X11R6/lib
else
	$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/local/lib
endif
	ln -sf $(SOFILEVER) $(SOFILE)
	ln -sf $(SOFILEVER) $(SOFILE).1
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C ../gtk-im; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C ../gtk3-im; fi
	if [ $(QT5_IM) = 'Y' ]; then $(MAKE) -C ../qt5-im; fi

LOCALLIB=/usr/local/$(LIB)

.PHONY: install
install:
	install -d "$(himelibdir)"
	install -m 755 $(SOFILEVER) "$(himelibdir)"
	cd "$(himelibdir)"; rm -f $(SOFILE); ln -s $(SOFILEVER) $(SOFILE); \
	ln -sf $(SOFILEVER) $(SOFILE).1

.PHONY: uninstall
uninstall:
	cd $(himelibdir) && rm -f $(SOFILEVER) $(SOFILE) $(SOFILE).1
	rmdir --ignore-fail-on-non-empty $(himelibdir)

# rules to rebuild $(DEPS), rebuild with -fPIC
hime-common.o: ../hime-common.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

hime-conf.o: ../hime-conf.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

hime-crypt.o: ../hime-crypt.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

hime-settings.o: ../hime-settings.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

locale.o: ../locale.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

im-addr.o: ../im-addr.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

pho2pinyin.o: ../pho2pinyin.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

pinyin.o: ../pinyin.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

util.o: ../util.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<


.PHONY: clean
clean:
	@echo "clean up"
	rm -f *.o *.so *.so.* *~ *.E *.db tags core.* .depend

.depend:
	@echo "building $@ ..."
	$(CCX) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== src/IMdkit/lib/Makefile ===
include ../../../config.mak

CFLAGS +=  -c $(OPTFLAGS) -fno-strength-reduce -DXIM_t -DTRANS_SERVER

ifeq ($(FREEBSD), 0)
  INC = -I../include -I/usr/X11R6/include
else
  INC = -I../include -I/usr/local/include/
endif

SRC = IMConn.c IMMethod.c FrameMgr.c i18nIMProto.c i18nAttr.c i18nMethod.c i18nUtil.c i18nPtHdr.c i18nIc.c i18nClbk.c i18nX.c

OBJ = $(SRC:.c=.o)

all: libXimd.a

libXimd.a: $(OBJ)
	@echo "archiving $@ ..."
	@ar cr $@ $(OBJ)
	@ranlib $@

.c.o:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -c $<

clean:
	@echo "clean up"
	@rm -f libXimd.a *.o *.bak

=== debian/changelog ===
hime (0.9.11+dfsg-2build1) jammy; urgency=medium

  * No-change rebuild against Qt 5.15.3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Thu, 17 Mar 2022 16:12:24 +0300

hime (0.9.11+dfsg-2) unstable; urgency=medium

  * Use libayatana-appindicator (Closes: #956772)

 -- Yao Wei (魏銘廷) <mwei@debian.org>  Tue, 19 Jan 2021 16:50:41 +0800

hime (0.9.11+dfsg-1) unstable; urgency=medium

  * New upstream version 0.9.11+dfsg
  * debian/watch: Update source repo
  * d/patches/himelibdir: Repatch himelibdir
  * debian/control:
    - Change uploader mail address
    - Bump Standards-Version to 4.5.1

 -- Yao Wei (魏銘廷) <mwei@debian.org>  Wed, 30 Dec 2020 20:49:14 +0800

=== debian/control ===
Source: hime
Section: utils
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@debian.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>,
Standards-Version: 4.5.1
Homepage: http://hime-ime.github.io
Build-Depends: debhelper-compat (= 13),
               dpkg-dev (>= 1.16.1~),
               libanthy-dev,
               libayatana-indicator-dev,
               libayatana-indicator3-dev,
               libchewing3-dev,
               libgtk2.0-dev (>= 2.20.0),
               libgtk-3-dev,
               libxtst-dev,
               qtbase5-private-dev,
               qtchooser,
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/hime.git
Vcs-Browser: https://salsa.debian.org/debian/hime

Package: hime
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime-data,
         hime-tables,
         libhime,
Recommends: im-config,
            hime-gtk2-immodule,
            hime-gtk3-immodule,
Suggests: hime-anthy,
          hime-chewing,
          hime-qt4-immodule,
          hime-qt5-immodule,
          gcin-voice,
Description: GTK+ based input method for Chinese users
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 To use HIME, the correspondence immodule packages also need to be installed.
 They are:
 .
  * hime-gtk2-immodule for GTK2
  * hime-gtk3-immodule for GTK3
  * hime-qt5-immodule for Qt5

Package: hime-data
Architecture: all
Depends: ${misc:Depends},
Description: icons, locales and scripts for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains icons, locales, scripts and other architecture-
 independent things.

Package: hime-tables
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: input method tables for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains architecture-dependent input method tables.

Package: libhime
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: library for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains library for HIME.

Package: hime-gtk2-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Breaks: hime (<< 0.9.10+git20150821+dfsg-1),
Replaces: hime (<< 0.9.10+git20150821+dfsg-1),
Description: GTK2 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK2 input method module (immodule) for HIME.

Package: hime-gtk3-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: GTK3 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK3 input method module (immodule) for HIME.

Package: hime-qt5-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: Qt5 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the Qt5 input method module (immodule) for HIME.

Package: hime-anthy
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
         anthy,
Description: support library to use Anthy in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use anthy in HIME.

Package: hime-chewing
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: support library to use Chewing in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use chewing in HIME.

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/hime-$1\.tar\.gz/,dversionmangle=s/\+(debian|dfsg|ds|deb|gh)\d*$//,repacksuffix=+dfsg \
  https://github.com/hime-ime/hime/tags .*/v?(\d\S+)\.tar\.gz

## hime 0.9.11+git20231221.g1c15f1f+dfsg

=== debian/changelog ===
hime (0.9.11+git20231221.g1c15f1f+dfsg-2) unstable; urgency=medium

  * d/contorl: Bump Standards-Version to 4.7.3:
    * Remove unnecessary Priority, Rules-Requires-Root.
  * Add hime-qt6-immodule (Closes: #1096097)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 25 Feb 2026 16:58:58 +0800

hime (0.9.11+git20231221.g1c15f1f+dfsg-1) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * New upstream version 0.9.11+git20231221.g1c15f1f+dfsg.
  * d/copyright: Fix array input method license.
  * Remove hime-gtk2-immodule (closes: #967526).
  * d/rules: Enable anthy, and chewing.
  * d/control: Update VCS-* to input method team.
  * d/salsa-ci.yml: Add Salsa CI config.
  * d/patches: Remove upstream applied patch.

  [ Andrew Lee (李健秋) ]
  * Import FTBFS fix patches from Alpine Linux.

  [ Dmitry Shachnev ]
  * Add a patch to use the standard libdir.
  * Use standard CFLAGS, but append -std=gnu17 (closes: #1096809).

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 23 Feb 2026 19:27:24 +0800

hime (0.9.11+dfsg-4) unstable; urgency=medium

  * Team upload.
  * debian/patches/0004-use-bash-in-hime-user-setup.patch: Add patch
    to use bash explicitly in hime-user-setup script. (Closes: #985250)

 -- Boyuan Yang <byang@debian.org>  Mon, 25 Dec 2023 20:26:55 -0500

hime (0.9.11+dfsg-3) unstable; urgency=medium

  * Team upload.
  * debian/control: Bump Standards-Version to 4.6.2.
  * debian/control: Drop build-dependency on GTK2 libayanata-appindicator
    support. (Closes: #1059009)
    + Note that the support to libayanata-appindicator is already broken
      with previous builds, and thus the removal of GTK2 appindicator
      support has no side effect at the moment.

 -- Boyuan Yang <byang@debian.org>  Wed, 20 Dec 2023 12:58:25 -0500

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,22 @@
 Source: hime
 Section: utils
-Priority: optional
 Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders: Yao Wei (魏銘廷) <mwei@debian.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>,
-Standards-Version: 4.5.1
-Homepage: http://hime-ime.github.io
+Standards-Version: 4.7.3
+Homepage: https://hime-ime.github.io
 Build-Depends: debhelper-compat (= 13),
-               dpkg-dev (>= 1.16.1~),
                libanthy-dev,
-               libayatana-indicator-dev,
                libayatana-indicator3-dev,
                libchewing3-dev,
-               libgtk2.0-dev (>= 2.20.0),
                libgtk-3-dev,
                libxtst-dev,
+               qt6-base-dev,
+               qt6-base-private-dev,
                qtbase5-private-dev,
-               qtchooser,
-Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/debian/hime.git
-Vcs-Browser: https://salsa.debian.org/debian/hime
+Vcs-Git: https://salsa.debian.org/input-method-team/hime.git
+Vcs-Browser: https://salsa.debian.org/input-method-team/hime
 
 Package: hime
 Architecture: any
@@ -31,11 +27,9 @@
          hime-tables,
          libhime,
 Recommends: im-config,
-            hime-gtk2-immodule,
             hime-gtk3-immodule,
 Suggests: hime-anthy,
           hime-chewing,
-          hime-qt4-immodule,
           hime-qt5-immodule,
           gcin-voice,
 Description: GTK+ based input method for Chinese users
@@ -45,13 +39,14 @@
  To use HIME, the correspondence immodule packages also need to be installed.
  They are:
  .
-  * hime-gtk2-immodule for GTK2
   * hime-gtk3-immodule for GTK3
   * hime-qt5-immodule for Qt5
+  * hime-qt6-immodule for Qt6
 
 Package: hime-data
 Architecture: all
 Depends: ${misc:Depends},
+Multi-Arch: foreign
 Description: icons, locales and scripts for HIME
  HIME Input Method Editor is a input method platform, which is forked
  from the famous gcin input method.
@@ -80,20 +75,6 @@
  .
  This package contains library for HIME.
 
-Package: hime-gtk2-immodule
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         hime (>= ${source:Version}),
-Breaks: hime (<< 0.9.10+git20150821+dfsg-1),
-Replaces: hime (<< 0.9.10+git20150821+dfsg-1),
-Description: GTK2 input method module with HIME as backend
- HIME Input Method Editor is a input method platform, which is forked
- from the famous gcin input method.
- .
- This package is the GTK2 input method module (immodule) for HIME.
-
 Package: hime-gtk3-immodule
 Architecture: any
 Multi-Arch: same
@@ -117,6 +98,18 @@
  from the famous gcin input method.
  .
  This package is the Qt5 input method module (immodule) for HIME.
+
+Package: hime-qt6-immodule
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         hime (>= ${source:Version}),
+Description: Qt6 input method module with HIME as backend
+ HIME Input Method Editor is a input method platform, which is forked
+ from the famous gcin input method.
+ .
+ This package is the Qt6 input method module (immodule) for HIME.
 
 Package: hime-anthy
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_CFLAGS_MAINT_APPEND = -fcommon

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

GTK3_IMMODULES := $(shell pkg-config --variable=libdir gtk+-3.0)/libgtk-3-0/gtk-query-immodules-3.0

%:
	dh $@ --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-anthy \
		--enable-chewing \
		--with-qt6-moc-path="/usr/lib/qt6/libexec/moc" \
		--with-qt6-im-module-path="$(shell qtpaths6 --query QT_INSTALL_PLUGINS)/platforminputcontexts" \
		--with-gtk=3.0 \
		$(NULL)

	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postinst.in > $(CURDIR)/debian/hime-gtk3-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postrm.in > $(CURDIR)/debian/hime-gtk3-immodule.postrm

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/hime/table
	ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_missing:
	dh_missing \
		--exclude=usr/include/hime-im-client-attr.h \
		--exclude=usr/include/hime-im-client.h \
		--exclude=usr/share/doc/hime/ChangeLog
